## eccodes 2.45.0

=== fortran/CMakeLists.txt ===
if( HAVE_FORTRAN )

    configure_file( eccodes_settings.h.in  eccodes_settings.h  @ONLY )

    set( srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
    set( bindir ${CMAKE_CURRENT_BINARY_DIR} )

    include_directories( ${srcdir} ${bindir} )

    # Our code is compiled with '-fallow-argument-mismatch' when compiling with
    # gfortran. The manual has to say this about it:
    #
    # > Some code contains calls to external procedures with mismatches between
    # > the calls and the procedure definition, or with mismatches between
    # > different calls. Such code is nonconforming, and is usually flagged with
    # > an error. This options degrades the error to a warning that can only be
    # > disabled by disabling all warnings via -w. Only a single occurrence per
    # > argument is flagged by this warning. -fallow-argument-mismatch is implied
    # > by -std=legacy.
    # >
    # > Using this option is strongly discouraged. It is possible to provide
    # > standard-conforming code that allows different types of arguments by
    # > using an explicit interface and TYPE(*).
    # From: https://gcc.gnu.org/onlinedocs/gcc-15.2.0/gfortran/Fortran-Dialect-Options.html
    #
    # Code in grib_types.f90, grib_f90.f90 is emitting this warning and for now we
    # want to silence it.
    # See https://jira.ecmwf.int/browse/ECC-2148
    if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
        set_source_files_properties(
            grib_types.f90
            grib_f90.f90
            PROPERTIES
                COMPILE_FLAGS "-w"
        )
    endif()

    ecbuild_add_executable( TARGET  grib_types
                            NOINSTALL
                            SOURCES grib_types.f90 grib_fortran_kinds.c )

    add_custom_command( OUTPUT  grib_kinds.h
                        COMMAND grib_types > grib_kinds.h
                        DEPENDS grib_types )

    if( ${ECCODES_SIZEOF_INT} EQUAL ${ECCODES_SIZEOF_LONG} )
        set( _long_int_interface    grib_f90_int.f90 )
        set( _long_int_interface_ec eccodes_f90_int.f90 )
    else()
        set( _long_int_interface    grib_f90_long_int.f90 )
        set( _long_int_interface_ec eccodes_f90_long_int.f90 )
    endif()

    if( ${ECCODES_SIZEOF_INT} EQUAL ${ECCODES_SIZEOF_SIZE_T} )
        set( _sizet_int_interface    grib_f90_int_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_int_size_t.f90 )
    else()
        set( _sizet_int_interface    grib_f90_long_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_long_size_t.f90 )
    endif()

    add_custom_command( OUTPUT  grib_f90.f90
                        COMMAND cat ${srcdir}/grib_f90_head.f90 ${srcdir}/${_long_int_interface} ${srcdir}/${_sizet_int_interface} ${srcdir}/grib_f90_tail.f90 > grib_f90.f90
                        DEPENDS grib_f90_head.f90 grib_f90_tail.f90 grib_kinds.h ${_long_int_interface} ${_sizet_int_interface} )
    add_custom_command( OUTPUT  eccodes_f90.f90
                        COMMAND cat ${srcdir}/eccodes_f90_head.f90 ${srcdir}/${_long_int_interface_ec} ${srcdir}/${_sizet_int_interface_ec} ${srcdir}/eccodes_f90_tail.f90 > eccodes_f90.f90
                        DEPENDS eccodes_f90_head.f90 eccodes_f90_tail.f90 grib_kinds.h ${_long_int_interface_ec} ${_sizet_int_interface_ec} )


    # Note: $<BUILD_INTERFACE:...> will be present only while building (for the whole bundle),
    # whereas $<INSTALL_INTERFACE:...> is only present once you install the package / bundle
    ecbuild_add_library( TARGET          eccodes_f90
                         SOURCES         grib_fortran.cc grib_f90.f90 eccodes_f90.f90 grib_kinds.h
                         GENERATED       grib_f90.f90 eccodes_f90.f90
                         PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
                                         $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>
                         PRIVATE_LIBS    eccodes ${ECCODES_PTHREADS_LIBRARIES} )

    if( DEFINED ecbuild_VERSION AND NOT ${ecbuild_VERSION} VERSION_LESS 3.1 )
        # Installed module directory is not in the PUBLIC INCLUDES!
        target_include_directories( eccodes_f90 PUBLIC $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}> )

        # NOTE: When eccodes accepts ecbuild 3.0 as minimum requirement,
        # this should instead be written inside the ecbuild_add_library macro with:
        #    PUBLIC_INCLUDES $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>
    endif()

    add_custom_command( TARGET     eccodes_f90 POST_BUILD
                        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/eccodes.mod ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod ${CMAKE_BINARY_DIR}/include )

    # Add the eccodes module file as well
    #set(_eccodes_mod "${CMAKE_Fortran_MODULE_DIRECTORY}/eccodes.mod" )

    #add_custom_command(
    #    OUTPUT ${_eccodes_mod}
    #    WORKING_DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}
    #    #COMMAND ${CMAKE_COMMAND} -E create_symlink "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    #COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    COMMAND "/usr/bin/sh" "-c" "if test -f GRIB_API.mod; then ln -s GRIB_API.mod ECCODES.mod; fi"
    #    COMMAND "/usr/bin/sh" "-c" "if test -f grib_api.mod; then ln -s grib_api.mod eccodes.mod; fi"
    #   DEPENDS eccodes_f90
    #    VERBATIM
    #)
    #add_custom_target(add_eccodes_mod ALL DEPENDS ${_eccodes_mod})

    ecbuild_add_resources( TARGET fortran_resources
                           PACK
                            grib_api_constants.h grib_api_externals.h
                            grib_api_visibility.h grib_types.f90 create_grib_f90.sh
                            grib_f90.f90.head grib_f90.f90.tail grib_f90_int.f90 grib_f90_long_int.f90
                            grib_f90_int_size_t.f90 grib_f90_long_size_t.f90

                            eccodes_visibility.h eccodes_constants.h
                            eccodes_f90.f90.head eccodes_f90.f90.tail eccodes_f90_int.f90 eccodes_f90_long_int.f90
                            eccodes_f90_int_size_t.f90 eccodes_f90_long_size_t.f90

                            same_int_long.f90 same_int_size_t.f90 grib_fortran_kinds.c )



### installation

    # Install the generated .mod file
    # install( CODE "EXECUTE_PROCESS (COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR} ${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR})" )

    # Install the contents of the fortran module directory
    if(ECBUILD_INSTALL_FORTRAN_MODULES)
        install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/  DESTINATION ${INSTALL_INCLUDE_DIR} )
    endif()

    # Install the eccodes module file as a copy of the grib api mod file.
    # Note: the mod filename can be lowercase or uppercase!
    # First try the lowercase one. Specify OPTIONAL so if it fails it carries on
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod
    #                 RENAME eccodes.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )
    # Now try the uppercase mod file
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/GRIB_API.mod
    #                 RENAME ECCODES.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )

endif()

=== memfs/CMakeLists.txt ===
# Note: the count 11 of generated C files must match
#       the 'generated_c_files' list
list( APPEND memfs_args
      --count 13
      --output ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen
)

set( generated_c_files
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_000.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_001.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_002.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_003.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_004.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_005.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_006.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_007.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_008.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_009.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_010.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_011.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_012.c
    ${CMAKE_CURRENT_BINARY_DIR}/memfs_gen_final.c)

if( NOT HAVE_PRODUCT_BUFR )
  list( APPEND memfs_args --exclude bufr)
endif()

if( NOT HAVE_PRODUCT_GRIB )
  list( APPEND memfs_args --exclude grib)
endif()

add_custom_command(
  OUTPUT ${generated_c_files}
  COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/memfs.py
    ${memfs_args}
    ${PROJECT_SOURCE_DIR}/definitions
    ${PROJECT_SOURCE_DIR}/samples
    ${PROJECT_SOURCE_DIR}/ifs_samples
  DEPENDS ${PROJECT_SOURCE_DIR}/memfs.py)

set_source_files_properties(
    ${generated_c_files} PROPERTIES OBJECT_DEPENDS
    "${PROJECT_SOURCE_DIR}/memfs.py"
    # "${PROJECT_SOURCE_DIR}/memfs.py" ${definition_files}"
    )

# No debug symbols on Cray (workaround for HPC-230)
if( CMAKE_C_COMPILER_ID MATCHES Cray )
  string( REGEX REPLACE "-g|-G[ 0-3]" " " CMAKE_C_FLAGS "${CMAKE_C_FLAGS}" )
  string( REGEX REPLACE "-g|-G[ 0-3]" " " CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_CAPS} "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_CAPS}}" )
endif()

if( HAVE_MEMFS )
    ecbuild_add_library(TARGET    eccodes_memfs
                        SOURCES   ${generated_c_files}
                        GENERATED ${generated_c_files})
endif()

=== tools/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND ecc_tools_sources
             grib_tools.cc
             grib_options.cc
             grib_tools.h )

if( EC_OS_NAME MATCHES "windows" )
  list( APPEND ecc_tools_sources wingetopt.cc )
endif()

# tools library
ecbuild_add_library( TARGET    ecc_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   ${ecc_tools_sources}
                     PRIVATE_LIBS      eccodes )
if( eccodes_HAVE_ECKIT_GEO )
    target_link_libraries( ecc_tools PUBLIC eckit )
endif()

# tools binaries
list( APPEND ecc_tools_binaries
             codes_info codes_count codes_split_file codes_export_resource
             grib_histogram grib_filter grib_ls grib_dump
             grib2ppm grib_set grib_get grib_get_data grib_copy
             grib_compare codes_parser grib_index_build bufr_index_build
             bufr_ls bufr_dump bufr_set bufr_get
             bufr_copy bufr_compare
             gts_get gts_compare gts_copy gts_dump gts_filter gts_ls )

list( APPEND ecc_tools_binaries_extra
             metar_dump metar_ls metar_compare metar_get metar_filter metar_copy
             grib_repair
             grib_to_json
             grib_check_gaussian_grid
             bufr_split_by_rdbSubtype )

# Install generic tools
foreach( tool ${ecc_tools_binaries} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            LIBS       ecc_tools )
endforeach()

# Install extra tools
# User must run cmake with -DECCODES_INSTALL_EXTRA_TOOLS=ON
foreach( tool ${ecc_tools_binaries_extra} )
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                            LIBS       ecc_tools )
endforeach()


# grib_count/bufr_count etc. Same source code, different executable names
ecbuild_add_executable( TARGET     grib_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     bufr_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     gts_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.cc
                        CONDITION  HAVE_NETCDF
                        LIBS       ecc_tools NetCDF::NetCDF_C )


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.cc
                        CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                        LIBS       ecc_tools )

ecbuild_add_executable( TARGET     codes_bufr_filter
                        SOURCES    bufr_filter.cc
                        LIBS       ecc_tools )


if( ECCODES_INSTALL_EXTRA_TOOLS )
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS enabled")
else()
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS disabled")
endif()
########################################

configure_file( codes_config.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/codes_config @ONLY )
file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/codes_config
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install( FILES ${CMAKE_BINARY_DIR}/bin/codes_config
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# BUFR compare script
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_compare_dir
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# bufr_filter script (See ECC-205)
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/tools/bufr_filter
    ${CMAKE_BINARY_DIR}/bin/ )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== src/eccodes/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND eccodes_src_files
    step_unit.cc
    step.cc
    step_utilities.cc
    grib_api.h
    eccodes.h

    action/Action.cc
    action/Alias.cc
    action/Gen.cc
    action/If.cc
    action/Switch.cc
    action/Section.cc
    action/List.cc
    action/While.cc
    action/Put.cc
    action/Meta.cc
    action/Remove.cc
    action/Rename.cc
    action/Assert.cc
    action/Template.cc
    action/Trigger.cc
    action/When.cc
    action/Concept.cc
    action/HashArray.cc
    action/Set.cc
    action/SetSarray.cc
    action/SetDarray.cc
    action/Noop.cc
    action/Write.cc
    action/Print.cc
    action/Close.cc
    action/Variable.cc
    action/Modify.cc
    action/TransientDarray.cc
    action/SetMissing.cc

    eccodes.cc
    grib_concept.cc
    grib_hash_array.cc
    grib_bufr_descriptor.cc
    grib_bufr_descriptors_array.cc
    grib_darray.cc
    grib_sarray.cc
    grib_oarray.cc
    grib_vdarray.cc
    grib_vsarray.cc
    grib_iarray.cc
    grib_viarray.cc
    codes_memfs.cc

    accessor/grib_accessors_list.cc
    grib_accessor_class.cc

    accessor/Accessor.cc
    accessor/G1FcPeriod.cc
    accessor/G1EndOfIntervalMonthly.cc
    accessor/MarsParam.cc
    accessor/Gen.cc
    accessor/Ascii.cc
    accessor/Bit.cc
    accessor/Bitmap.cc
    accessor/Bits.cc
    accessor/BitsPerValue.cc
    accessor/BufrElementsTable.cc
    accessor/BufrDataArray.cc
    accessor/BufrDataElement.cc
    accessor/BufrGroup.cc
    accessor/BufrStringValues.cc
    accessor/PackBufrValues.cc
    accessor/UnpackBufrValues.cc
    accessor/Group.cc
    accessor/NonAlpha.cc
    accessor/G1Bitmap.cc
    accessor/G2Bitmap.cc
    accessor/Concept.cc
    accessor/HashArray.cc
    accessor/DecimalPrecision.cc
    accessor/DivDouble.cc
    accessor/MultDouble.cc
    accessor/BudgDate.cc
    accessor/ValidityDate.cc
    accessor/ValidityTime.cc
    accessor/Bytes.cc
    accessor/CfVarName.cc
    accessor/ChangeAlternativeRowScanning.cc
    accessor/ChangeScanningDirection.cc
    accessor/CheckInternalVersion.cc
    accessor/Codeflag.cc
    accessor/SmartTable.cc
    accessor/SmartTableColumn.cc
    accessor/Codetable.cc
    accessor/CodetableUnits.cc
    accessor/CodetableTitle.cc
    accessor/StepHumanReadable.cc
    accessor/CountFile.cc
    accessor/CountTotal.cc
    accessor/Double.cc
    accessor/Element.cc
    accessor/Evaluate.cc
    accessor/G1Date.cc
    accessor/G1MonthlyDate.cc
    accessor/LibraryVersion.cc
    accessor/When.cc
    accessor/G1VerificationDate.cc
    accessor/G1DayOfTheYearDate.cc
    accessor/G1HalfByteCodeflag.cc
    accessor/G1ForecastMonth.cc
    accessor/G1StepRange.cc
    accessor/G2StepRange.cc
    accessor/DataG22OrderPacking.cc
    accessor/MarsStep.cc
    accessor/MessageCopy.cc
    accessor/MessageIsValid.cc
    accessor/Dictionary.cc
    accessor/LatLonIncrement.cc
    accessor/G2Date.cc
    accessor/G2Level.cc
    accessor/G2EndStep.cc
    accessor/G2LatLon.cc
    accessor/G2Lon.cc
    accessor/GlobalGaussian.cc
    accessor/GaussianGridName.cc
    accessor/Getenv.cc
    accessor/GtsHeader.cc
    accessor/JulianDay.cc
    accessor/JulianDate.cc
    accessor/ClosestDate.cc
    accessor/LatLonValues.cc
    accessor/Latitudes.cc
    accessor/Longitudes.cc
    accessor/OffsetFile.cc
    accessor/Scale.cc
    accessor/FromScaleFactorScaledValue.cc
    accessor/G2BitmapPresent.cc
    accessor/IbmFloat.cc
    accessor/IeeeFloat.cc
    accessor/Constant.cc
    accessor/Iterator.cc
    accessor/Message.cc
    accessor/Nearest.cc
    accessor/Ksec1Expver.cc
    accessor/Label.cc
    accessor/Long.cc
    accessor/Lookup.cc
    accessor/OctahedralGaussian.cc
    accessor/OctetNumber.cc
    accessor/HeadersOnly.cc
    accessor/Padding.cc
    accessor/Pad.cc
    accessor/PadTo.cc
    accessor/PadToEven.cc
    accessor/PadToMultiple.cc
    accessor/SectionPadding.cc
    accessor/PackingType.cc
    accessor/SectionPointer.cc
    accessor/Position.cc
    accessor/Signed.cc
    accessor/SignedBits.cc
    accessor/Section.cc
    accessor/StepInUnits.cc
    accessor/OptimalStepUnits.cc
    accessor/SectionLength.cc
    accessor/G1MessageLength.cc
    accessor/G1Section4Length.cc
    accessor/Size.cc
    accessor/RdbTimeGuessDate.cc
    accessor/ScaleValues.cc
    accessor/OffsetValues.cc
    accessor/Sprintf.cc
    accessor/Round.cc
    accessor/SpectralTruncation.cc
    accessor/Time.cc
    accessor/Transient.cc
    accessor/Trim.cc
    accessor/TransientDarray.cc
    accessor/Values.cc
    accessor/SimplePackingError.cc
    accessor/DataSimplePacking.cc
    accessor/CountMissing.cc
    accessor/DataShPacked.cc
    accessor/DataShUnpacked.cc
    accessor/NumberOfValuesDataRawPacking.cc
    accessor/DataG1SimplePacking.cc
    accessor/DataG1ShSimplePacking.cc
    accessor/DataShSimplePacking.cc
    accessor/DataDummyField.cc
    accessor/Variable.cc
    accessor/SecondOrderBitsPerValue.cc
    accessor/DataG2SimplePacking.cc
    accessor/DataG2SimplePackingWithPreprocessing.cc
    accessor/DataG2ShSimplePacking.cc
    accessor/DataG2ComplexPacking.cc
    accessor/DataG1SecondOrderRowByRowPacking.cc
    accessor/DataG1SecondOrderConstantWidthPacking.cc
    accessor/DataG1SecondOrderGeneralPacking.cc
    accessor/DataG1SecondOrderGeneralExtendedPacking.cc
    accessor/G2Grid.cc
    accessor/UnexpandedDescriptors.cc
    accessor/ExpandedDescriptors.cc
    accessor/BufrdcExpandedDescriptors.cc
    accessor/DataApplyBitmap.cc
    accessor/DataApplyBoustrophedonic.cc
    accessor/DataApplyBoustrophedonicBitmap.cc
    accessor/DataSecondaryBitmap.cc
    accessor/DataG1SecondaryBitmap.cc
    accessor/DataG2SecondaryBitmap.cc
    accessor/DataJpeg2000Packing.cc
    accessor/DataPngPacking.cc
    accessor/DataCcsdsPacking.cc
    accessor/DataRawPacking.cc
    accessor/DataComplexPacking.cc
    accessor/DataG1ComplexPacking.cc
    accessor/GdsIsPresent.cc
    accessor/SelectStepTemplate.cc
    accessor/LocalDefinition.cc
    accessor/G2Eps.cc
    accessor/G2Aerosol.cc
    accessor/G2Chemical.cc
    accessor/G2ConceptDir.cc
    accessor/Mtg2SwitchDefault.cc
    accessor/G2MarsLabeling.cc
    accessor/Md5.cc
    accessor/ProjString.cc
    accessor/NumberOfPoints.cc
    accessor/Suppressed.cc
    accessor/NumberOfPointsGaussian.cc
    accessor/NumberOfValues.cc
    accessor/NumberOfCodedValues.cc
    accessor/G1NumberOfCodedValuesShComplex.cc
    accessor/G1NumberOfCodedValuesShSimple.cc
    accessor/Dirty.cc
    accessor/Statistics.cc
    accessor/StatisticsSpectral.cc
    accessor/Unsigned.cc
    accessor/UnsignedBits.cc
    accessor/Raw.cc
    accessor/BufrSimpleThinning.cc
    accessor/BufrExtractSubsets.cc
    accessor/BufrExtractAreaSubsets.cc
    accessor/BufrExtractDatetimeSubsets.cc
    accessor/Spd.cc
    accessor/Sum.cc
    accessor/ToInteger.cc
    accessor/ToDouble.cc
    accessor/ToString.cc
    accessor/Sexagesimal2Decimal.cc
    accessor/Vector.cc
    accessor/LongVector.cc
    accessor/AbstractVector.cc
    accessor/AbstractLongVector.cc
    accessor/ReferenceValueError.cc
    accessor/Uint16.cc
    accessor/Uint32.cc
    accessor/Uint32LittleEndian.cc
    accessor/Uint64.cc
    accessor/Uint64LittleEndian.cc
    accessor/Uint8.cc
    accessor/Blob.cc
    accessor/DataG2BifourierPacking.cc
    accessor/DataRunLengthPacking.cc
    accessor/GridSpec.cc
    accessor/G2ParamConceptFilename.cc
    accessor/G2Probability.cc
    accessor/G2WavePeriodRange.cc

    grib_jasper_encoding.cc
    grib_openjpeg_encoding.cc
    grib_index.cc
    geo/grib_gaussian_reduced.cc
    grib_loader_from_handle.cc
    grib_bits.cc
    grib_ibmfloat.cc
    grib_ieeefloat.cc
    grib_memory.cc
    grib_buffer.cc

    dumper/Debug.cc
    dumper/Default.cc
    dumper/BufrEncodeC.cc
    dumper/BufrEncodeFilter.cc
    dumper/BufrEncodeFortran.cc
    dumper/BufrEncodePython.cc
    dumper/BufrDecodeC.cc
    dumper/BufrDecodeFilter.cc
    dumper/BufrDecodeFortran.cc
    dumper/BufrDecodePython.cc
    dumper/BufrSimple.cc
    dumper/Json.cc
    dumper/GribEncodeC.cc
    dumper/Wmo.cc

    grib_context.cc
    grib_date.cc
    grib_fieldset.cc
    grib_filepool.cc
    geo/grib_geography.cc
    grib_handle.cc
    grib_hash_keys.cc
    grib_io.cc
    grib_trie.cc
    grib_trie_with_rank.cc
    grib_itrie.cc
    grib_rules.cc
    grib_keys_iterator.cc
    bufr_keys_iterator.cc
    grib_parse_utils.cc
    grib_query.cc
    grib_scaling.cc
    grib_templates.cc
    grib_dependency.cc
    grib_value.cc
    grib_errors.cc

    grib_arguments.cc

    expression/Expression.cc
    expression/Binop.cc
    expression/LogicalAnd.cc
    expression/LogicalOr.cc
    expression/IsInDict.cc
    expression/True.cc
    expression/StringCompare.cc
    expression/Unop.cc
    expression/Functor.cc
    expression/Accessor.cc
    expression/IsInList.cc
    expression/IsInteger.cc
    expression/Length.cc
    expression/Long.cc
    expression/Double.cc
    expression/String.cc
    expression/SubString.cc

    geo/nearest/Nearest.cc
    geo/nearest/Gen.cc
    geo/nearest/Healpix.cc
    geo/nearest/LambertAzimuthalEqualArea.cc
    geo/nearest/LambertConformal.cc
    geo/nearest/LatlonReduced.cc
    geo/nearest/Mercator.cc
    geo/nearest/PolarStereographic.cc
    geo/nearest/Reduced.cc
    geo/nearest/Regular.cc
    geo/nearest/SpaceView.cc

    geo/iterator/Iterator.cc
    geo/iterator/Gaussian.cc
    geo/iterator/GaussianReduced.cc
    geo/iterator/Gen.cc
    geo/iterator/Healpix.cc
    geo/iterator/LambertAzimuthalEqualArea.cc
    geo/iterator/LambertConformal.cc
    geo/iterator/Latlon.cc
    geo/iterator/LatlonReduced.cc
    geo/iterator/Mercator.cc
    geo/iterator/PolarStereographic.cc
    geo/iterator/Regular.cc
    geo/iterator/SpaceView.cc

    codes_util.cc
    grib_util.cc
    bufr_util.cc
    string_util.cc
    functions.cc
    grib_accessor_class.h
    grib_accessor_factory.h
    grib_api_internal.h
    eccodes_prototypes.h
    grib_dumper_factory.cc
    grib_iterator_factory.cc
    grib_nearest_factory.cc
    grib_yacc.h
    md5_core.h
    md5_core.cc
    grib_optimize_decimal_factor.cc
    eccodes_windef.h
    # We ship our own generated lex/yacc C files
    grib_yacc.cc  grib_lex.cc )

list( APPEND eccodes_extra_src_files
    grib_bits_fast_big_endian.cc grib_bits_any_endian.cc
    grib_bits_fast_big_endian_vector.cc grib_bits_any_endian_vector.cc
    grib_bits_fast_big_endian_simple.cc grib_bits_any_endian_simple.cc
    grib_bits_fast_big_endian_omp.cc grib_bits_any_endian_omp.cc
    encode_double_array.cc
    grib_bits_ibmpow.cc
    grib_bits_ibmpow_opt.cc )

if(UNIX)
    ecbuild_get_date(eccodes_BUILD_DATE)
endif()
configure_file( grib_api_version.cc.in grib_api_version.cc @ONLY )
configure_file( eccodes_version.h.in eccodes_version.h @ONLY )

# We ship our own generated lex/yacc C files
#ecbuild_generate_yy(YYPREFIX  grib_yy
#                    YACC      griby
#                    LEX       gribl
#                    FLEX_FLAGS " "
#                    LEX_FLAGS  " "
#                    BISON_FLAGS "-y"
#                    YACC_FLAGS  "-y"
#                    DEPENDANT action.cc )

if( HAVE_MEMFS )
    list(APPEND ECCODES_EXTRA_LIBRARIES eccodes_memfs)
endif()

if( eccodes_HAVE_GEOGRAPHY AND eccodes_HAVE_ECKIT_GEO )
    list( APPEND eccodes_src_files
        config/LibEccodes.cc
        config/LibEccodes.h

        geo/BasicAngle.cc
        geo/BasicAngle.h
        geo/EckitMainInit.cc
        geo/EckitMainInit.h
        geo/Geo.cc
        geo/Geo.h
        geo/GeoIterator.cc
        geo/GeoIterator.h
        geo/GribFromSpec.cc
        geo/GribFromSpec.h
        geo/GribToSpec.cc
        geo/GribToSpec.h )

=== debian/changelog ===
eccodes (2.45.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1124157

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 30 Jan 2026 06:51:09 +0000

=== debian/control ===
Source: eccodes
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran,
  gfortran,
  flang-21 [!s390x],
  ecbuild (>= 3.7.0),
  libeckit-dev,
  libjpeg-dev, 
  libpng-dev, 
  flex, 
  bison, 
  quilt,
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libeccodes-dev
Standards-Version: 4.7.3
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org/science-team/eccodes.git -b debian/latest

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: libeccodes-tools
Depends: libeccodes0 (= ${binary:Version}), 
  ${misc:Depends}, ${shlibs:Depends},  ${fortran:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

DEB_BUILD_MAINT_OPTIONS:= hardening=+all
export DEB_BUILD_MAINT_OPTIONS

FC_DEFAULT:= gfortran
FC_OPTIONAL:= flang-21
export FC:=gfortran

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR=/usr/include/$(DEB_HOST_MULTIARCH)
DESTDIR=$(CURDIR)/debian/tmp
CMAKEDIR:=debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes

BUILDDIR:=debian/build
BUILDDIR_DEFAULT:=$(BUILDDIR)-$(FC_DEFAULT)

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export LDFLAGS CFLAGS CPPFLAGS CXXFLAGS

# Pull in ecbuild macros rather than local ones
BUILD_FLAGS =  \
	-DENABLE_INSTALL_ECCODES_DEFINITIONS=ON \
	-DENABLE_INSTALL_ECCODES_SAMPLES=ON \
	-DENABLE_PNG=ON \
	-DENABLE_ECKIT_GEO=ON \
	-DENABLE_AEC=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_RELATIVE_RPATHS=OFF \
	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
	-DENABLE_ALIGN_MEMORY=ON \
	-DENABLE_GRIB_TIMER=ON \
	-DENABLE_ECCODES_OMP_THREADS=On  \

%:
	dh $@ --buildsystem=ecbuild --builddirectory=${BUILDDIR_DEFAULT}  --no-parallel --with fortran

define dh_build_fortran_TEMPLATE =
  dh_build_fortran_$(1):
	@echo DEBUGF  CALLING dh_build_fortran_$(1)
	dh_auto_build --builddirectory=${BUILDDIR}-$(1) 
	@echo DEBUGF  LEAVING dh_build_fortran_$(1)
endef
$(eval $(call foreach_fc_execute_before,build))

define dh_configure_fortran_TEMPLATE =
  dh_configure_fortran_$(1):
	@echo DEBUGF ENTERING dh_configure_fortran_$(1)
	FFLAGS=`dh_fortran get_fc_flags --fc $(1)`  \
	LDFLAGS=`dh_fortran get_ld_flags --fc $(1)`  \
	dh_auto_configure --builddirectory=${BUILDDIR}-$(1)  -- \
			${BUILD_FLAGS} \
			-DCMAKE_Fortran_COMPILER=$(1) 
	@echo DEBUGF LEAVING dh_configure_fortran_$(1)
endef
$(eval $(call foreach_fc_execute_before,configure))


define dh_install_fortran_TEMPLATE =
  dh_install_fortran_$(1):
	@echo DEBUGF  CALLING dh_install_fortran_$(1)
	dh_fortran_lib -p libeccodes-dev --flavor $(1) $(BUILDDIR)-$(1)/lib/libeccodes_f90_static.a
	dh_fortran_lib -p libeccodes-dev --flavor $(1) $(BUILDDIR)-$(1)/lib/libeccodes_f90.so
	dh_fortran_lib -p libeccodes0    --flavor $(1) $(BUILDDIR)-$(1)/lib/libeccodes_f90.so.0
	@echo DEBUGF  LEAVING dh_install_fortran_$(1)
endef
$(eval $(call foreach_fc_execute_before,install))

# TODO fix static installs properly with dh_fortran_cmake

override_dh_install:
	cd $(BUILDDIR_DEFAULT) && $(MAKE) install DESTDIR=$(DESTDIR)  
	# Move to multiarch dir
	mkdir -p  $(DESTDIR)/$(INCDIR)
	mv $(DESTDIR)/usr/include/*.h $(DESTDIR)/$(INCDIR)
	dh_install
	# Setup cmake files for magics++, metview, etc. (full builds only)
	[ -e $(CMAKEDIR)/eccodes-targets.cmake ] && ( \
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' 	$(CMAKEDIR)/eccodes-targets.cmake  ; \
	sed -i -e 's%/usr/lib/libeccodes%${LIBDIR}/libeccodes%' 			$(CMAKEDIR)/eccodes-targets-release.cmake ;\
	sed -i -e 's%/libeccodes_f90_static.a%/fortran/gnu/libeccodes_f90_static.a%' 	$(CMAKEDIR)/eccodes-targets-release.cmake ;\
	sed -i -e 's%$${_IMPORT_PREFIX}%/usr%'                  			$(CMAKEDIR)/eccodes-targets-release.cmake ;\
	sed -i -e 's%${LIBDIR}/libopenjpeg.so;%%' 					$(CMAKEDIR)/eccodes-targets-release.cmake ;\
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-targets-release.cmake ;\
	sed -i -e 's%;${LIBDIR}/libopenjpeg.so%%g' 					$(CMAKEDIR)/eccodes-config.cmake ;\
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake/eccodes%${LIBDIR}/cmake/eccodes%g' $(CMAKEDIR)/eccodes-config.cmake ;\
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-config.cmake ;\
	for f in eccodes-config.cmake eccodes-import.cmake ; do \
		sed -i -e 's%${CURDIR}%/build/eccodes%g' $(CMAKEDIR)/$$f ; \
		sed -i -e 's%$${eccodes_BASE_DIR}/share%/usr/share%g' $(CMAKEDIR)/$$f ; \
		done ; \
        ) || true
	# file exists on full builds only
	[ - e debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h ] && ( \
		sed -i -e 's%${CURDIR}%/build/eccodes%g'  debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h \
		) || true	


execute_after_dh_auto_clean:
	rm -rf debian/build-*

execute_after__dh_fixperms:
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/F90/include.sh
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/extra/include.sh
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/extra/f_clone.f90
	-chmod +x debian/libeccodes-data/usr/share/eccodes/definitions/installDefinitions.sh
	-chrpath -d debian/libeccodes0/$(LIBDIR)/*.so.0
	-chrpath -d debian/libeccodes-tools/usr/bin/grib_to_netcdf


define dh_test_fortran_TEMPLATE =
  dh_test_fortran_$(1):
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	(LD_LIBRARY_PATH=$(BUILDDIR)-$(1)/lib dh_auto_test --builddirectory=$(BUILDDIR)-$(1) || true)
endif
endef
$(eval $(call foreach_fc_execute_before,test))

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/ecmwf/eccodes
